<template>
    <div class="post">
        <div style="font-size: 40px">
            <el-icon @click="router.back">
                <Back style="width: 3em; height: 3em; margin-right: 8px; cursor: pointer;" />
            </el-icon>
        </div>
        <h2>{{ title }}</h2>
        <div>
            <div v-html="content" />
        </div>
        <div class="author">author:
            <router-link v-if="typeof user.uuid !== 'undefined' && user.email !== author"
                :to="`/communicator/` + author">
                <p class="user-card-wrapper">
                    <UserCard :email="author" />
                </p>
            </router-link>
            <p v-if="typeof user.uuid !== 'undefined' && user.email === author" class="user-card-wrapper">
                <UserCard :email="author" />
            </p>
            <a v-if="typeof user.uuid === 'undefined'" class="user-card-wrapper" style="cursor: pointer;" @click="redirectToLogin">
                <UserCard :email="author" />
            </a>
        </div>
        <div class="created">
            {{ (new Date(created)).toLocaleDateString() }},
            {{ (new Date(created)).toLocaleTimeString() }}
        </div>
        <div class="rating-wrapper">
            <span style="margin-left: 16px">
                {{ positiveNumber }}
            </span>
            <span style="margin-left: 28px">
                {{ negativeNumber }}
            </span>
        </div>
        <div v-if="typeof user.uuid !== 'undefined'" class="rate-wrapper">
            <img @click="positivePost" :src="yourRaiting === 'positive' ? thumbUpGreen : thumbUp"
                style="width: 20px; margin: 10px" />
            <img @click="negativePost" :src="yourRaiting === 'negative' ? thumbDownRed : thumbDown"
                style="width: 20px; margin: 7px" />
        </div>
        <div class="add-comment-wrapper">
            <el-input v-if="typeof user.email !== 'undefined'" v-model="commentContent" placeholder="Comment" />
            <el-tooltip v-if="typeof user.email !== 'undefined'" class="box-item" effect="dark" content="Add comment"
                placement="top-start">
                <el-button @click="addComment" class="add-comment-button" type="success" :icon="DArrowRight" circle />
            </el-tooltip>

        </div>
        <CommentComponent v-for="(comment, index) in comments" :key="index" :id="comment.id" :content="comment.content"
            :username="comment.userName" />
    </div>
</template>
<script lang="ts" setup>
import { ref, Ref, onMounted } from 'vue';
import axios from 'axios';
import useEmitter from '../composables/useEmitter';
import { DArrowRight, Back } from "@element-plus/icons-vue";

import Comment from '../interfaces/Comment'
import { useStore } from '../stores';
import { useRoute } from 'vue-router';
import { storeToRefs } from 'pinia';

import CommentComponent from '../components/Comment.vue';
import router from '../router';
// @ts-ignore
import thumbDown from '@/assets/thumb-down.jpg';
// @ts-ignore
import thumbDownRed from '@/assets/thumb-down-red.jpg';
// @ts-ignore
import thumbUp from '@/assets/thumb-up.jpg';
// @ts-ignore
import thumbUpGreen from '@/assets/thumb-up-green.jpg';

import UserCard from '../components/UserCard.vue'
const route = useRoute();
const emitter = useEmitter();

const { id, author } = route.params;
const store = useStore();
const { user } = storeToRefs(store);
// const props = defineProps<Props>()
const title: Ref<String> = ref('');
const content: Ref<String> = ref('');
const created: Ref<Date> = ref(new Date());

const positiveNumber: Ref<number> = ref(0);
const negativeNumber: Ref<number> = ref(0);
const yourRaiting: Ref<String> = ref('');
const commentContent: Ref<String> = ref('');
const comments: Ref<Comment[]> = ref([]);

// const instance = getCurrentInstance();

onMounted(() => {
    //document.querySelector('*[role="application"]').style.width='100%';
    getPost();
    // positivePost();
    // negativePost();
    getNegativeNumber();
    getPositiveNumber();
    getComments();
    if (typeof user.value.uuid !== 'undefined') {
        getYourRating();
    }
});

function getPost() {
    // @ts-ignore
    axios.get(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/post/${id}`)
        .then(({ data }) => {
            title.value = data.title;
            content.value = data.content;
            created.value = data.created;
            console.log(data);
        })
        .catch(err => {
            console.error(err);
        })
}

function addComment() {
    // @ts-ignore
    axios.post(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/comment/post/${id}`,
        { content: commentContent.value, uuid: user.value.uuid }
    ).then(({ data }) => {
        commentContent.value = '';
        getComments();
    }).catch(err => {
        console.error(err);
    })
}

function getComments() {
    // @ts-ignore
    axios.get(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/comment/post/${id}`)
        .then(({ data }) => {
            comments.value = data;
        }).catch(err => {
            console.error(err);
        })
}

function positivePost() {
    // @ts-ignore
    axios.put(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/post/positive/${id}`,
        { uuid: user.value.uuid }
    )
        .then(({ data }) => {
            getPositiveNumber();
            getNegativeNumber();
            getYourRating();
            // instance?.proxy?.$forceUpdate();
        }).catch(err => {
            console.error(err);
        })
}

function negativePost() {
    // @ts-ignore
    axios.put(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/post/negative/${id}`,
        { uuid: user.value.uuid }
    )
        .then(({ data }) => {
            getPositiveNumber();
            getNegativeNumber();
            getYourRating();
            // instance?.proxy?.$forceUpdate();
        }).catch(err => {
            console.error(err);
        })
}

function getPositiveNumber() {
    // @ts-ignore
    axios.get(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/post/positive/${id}`)
        .then(({ data }) => {
            positiveNumber.value = data;
        }).catch(err => {
            console.error(err);
        })
}

function getNegativeNumber() {
    // @ts-ignore
    axios.get(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/post/negative/${id}`)
        .then(({ data }) => {
            negativeNumber.value = data;
        }).catch(err => {
            console.error(err);
        })
}

function getYourRating() {
    // @ts-ignore
    axios.post(`${import.meta.env.VITE_HOST}:${import.meta.env.VITE_PORT}/api/v1/user/post/${id}/`, {
        uuid: user.value.uuid
    }).then(({ data }) => {
        yourRaiting.value = data;
    }).catch(err => {
        console.error(err);
    })
}

function redirectToLogin() {
    emitter.emit('login-before-talk', { author });
}

</script>
<style scoped lang="scss">
*[role="application"] {
    width: 100% !important;
}

.post {
    border: 1px solid rgba(10, 10, 10, .1);
    padding: 10px;
    margin: 10px;

    .author,
    .created {
        text-align: right;
    }

    .add-comment {
        &>a {
            cursor: pointer;
        }
    }

    .add-comment-wrapper {
        display: flex;
        justify-content: right;

        .add-comment-button {
            left: 20px;
        }

       
    }
    .user-card-wrapper {
            display: flex;
            justify-content: end;
            margin-top: 14px
        }
}
</style>